class Arbitrator {

   private static final int NUM_NODES = 2; // for two nodes only
                       // Dekker's solution:  take turns backing off.
   private volatile boolean[] desiresCS = {false, false};
   private volatile int turn = 0;

   public Arbitrator(int numNodes) {
      if (numNodes != NUM_NODES) {
         System.err.println("Arbitrator: numNodes=" + numNodes
            + " which is != " + NUM_NODES);
         System.exit(1);
      }
   }

   private int other(int i) { return (i + 1) % NUM_NODES; }

   public void wantToEnterCS(int i) {       // pre-protocol
      desiresCS[i] = true;
      while (desiresCS[other(i)]) {
         if (turn != i) {
            desiresCS[i] = false;      // back off
            while (turn != i) /* busy-wait */ ;
            desiresCS[i] = true;
         }
      }
   }

   public void finishedInCS(int i) {        // post-protocol
      desiresCS[i] = false;
      turn = other(i);
   }
}
