class Arbitrator {

   private static final int NUM_NODES = 2; // for two nodes only
                          // Lamport's bakery ticket algorithm.
   private volatile int[] number = {0, 0};

   public Arbitrator(int numNodes) {
      if (numNodes != NUM_NODES) {
         System.err.println("Arbitrator: numNodes=" + numNodes
            + " which is != " + NUM_NODES);
         System.exit(1);
      }
   }

   private int other(int i) { return (i + 1) % NUM_NODES; }

   public void wantToEnterCS(int i) {       // pre-protocol
      number[i] = 1;
      number[i] = number[other(i)] + 1;
      while (!(number[other(i)] == 0 || number[i] < number[other(i)]
         || // break a tie
      (number[i] == number[other(i)] && i == 1))) /* busy-wait */ ;
   }

   public void finishedInCS(int i) {        // post-protocol
      number[i] = 0;
   }
}
