package Utilities;

import java.util.Random;
import Synchronization.*;

public abstract class MyObject extends Object {

   private static final long startTime = System.currentTimeMillis();
   private String name = null;
   private static final Random rnd = new Random();

   protected MyObject() {super();}   // this class is designed
                                     // to be extended only
   protected MyObject(String name) {
      super();
      this.name = name;
   }

   protected final String getName() {return name;}

   protected final String getThreadName() {
      return Thread.currentThread().getName();
   }

   protected static final void nap(int ms) {
      try {
         Thread.sleep(ms);
      } catch (InterruptedException e) {
         System.err.println("interrupted out of sleep");
      }
   }

   protected static final long age() {
      return System.currentTimeMillis() - startTime;
   }

   protected static final void seed(long theSeed)
      { rnd.setSeed(theSeed); }
   protected static final void seed(int theSeed)
      { rnd.setSeed((long)theSeed); }
   protected static final void seed(float theSeed)
      { rnd.setSeed((long)theSeed); }
   protected static final void seed(double theSeed)
      { rnd.setSeed((long)theSeed); }

   // returns double in range [0, 1)
   protected static final double random() {
      return rnd.nextDouble();
   }

   // returns double in range [0, ub)
   protected static final double random(int ub) {
      return rnd.nextDouble()*ub;
   }

   // returns double in range [lb, ub)
   protected static final double random(int lb, int ub) {
      return lb + rnd.nextDouble()*(ub - lb);
   }

   // syntactic sugar for semaphores
   protected static final void P(Semaphore s) { s.P(); }
   protected static final void V(Semaphore s) { s.V(); }

   // syntactic sugar for named condition variables
   protected final void wait(ConditionVariable cv)
      { cv.waitCV(this); }
   protected final void notify(ConditionVariable cv)
      { cv.notifyCV(this); }
   protected final boolean empty(ConditionVariable cv)
      { return cv.emptyCV(this); }

   // syntactic sugar for message passing
   protected static final void send(MessagePassing mp, Object o) {
      mp.send(o);
   }
   protected static final Object receive(MessagePassing mp) {
      return mp.receive();
   }
   protected static final void send(MessagePassing mp, int o) {
      mp.send(o);
   }
   protected static final int receiveInt(MessagePassing mp) {
      return mp.receiveInt();
   }
   protected static final void send(MessagePassing mp, double o) {
      mp.send(o);
   }
   protected static final double receiveDouble(MessagePassing mp) {
      return mp.receiveDouble();
   }
}
