package Utilities;

public class Scheduler extends Thread {

   private int timeSlice = 0; // milliseconds
   private boolean debug = false;

   public Scheduler(String name, int timeSlice, boolean debug) {
      super(name);
      this.timeSlice = timeSlice;
      this.debug = debug;
      setPriority(MAX_PRIORITY);
      System.out.println("Scheduler " + getName()
         + " constructed with timeSlice="
         + timeSlice + " and priority=" + getPriority());
      start();
   }

   public void run() {
      System.out.println("Scheduler " + getName() + " running");
      while (true) {
         try {
            sleep(timeSlice);
         } catch (InterruptedException e) {
            System.err.println(getName() + " interrupted out of sleep");
         }
         // this highest-priority thread waking up sends the currently
         // executing thread to the end of the round-robin ready queue
         if (debug)
            System.out.println("Scheduler " + getName() + " slicing");
      }
   }
}
